#!/bin/sh

COLOR="\e[32m"
RESET="\e[0m"

finish_installation() {
    EPUBLICKEY=$(grep pubkey /web/cgi-bin2/cryptophotoconf.tcl | sed 's/.*"\([a-zA-Z0-9]*\)".*/\1/')   #"
    EPRIVATEKEY=$(grep privkey /web/cgi-bin2/cryptophotoconf.tcl | sed 's/.*"\([a-zA-Z0-9]*\)".*/\1/') #"
    ESALT=$(grep salt /web/cgi-bin2/cryptophotoconf.tcl | sed 's/.*"\([a-zA-Z0-9]*\)".*/\1/')      #"
    ECPENABLED=$(grep cpenabled /web/cgi-bin2/cryptophotoconf.tcl | sed 's/.* \([0-9]*\)/\1/')  #'

    if [[ ! -n "${ESALT/[ ]*\n/}" ]]; then
        ESALT=$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | head -c 32)
    fi

    echo -e "Configure CryptoPhoto plugin (see ${COLOR}https://cryptophoto.com/info/admin$RESET on how to aquire API keys)"

    read -p "Enter CryptoPhoto Public API key [$EPUBLICKEY]: " PUBLICKEY
    read -p "Enter CryptoPhoto Private API key [$EPRIVATEKEY]: " PRIVATEKEY

    echo "A SALT (random string) is needed to hash your users IDs. Once set, it must not be changed."
    read -p "Enter SALT[$ESALT]: " SALT

    if [[ ! -n "${PUBLICKEY/[ ]*\n/}" ]]; then
        PUBLICKEY=$EPUBLICKEY
    fi

    if [[ ! -n "${PRIVATEKEY/[ ]*\n/}" ]]; then
        PRIVATEKEY=$EPRIVATEKEY
    fi

    if [[ ! -n "${SALT/[ ]*\n/}" ]]; then
        SALT=$ESALT
    fi

    echo -e "Updating ${COLOR}pubkey$RESET in $COLOR/web/cgi-bin2/cryptophotoconf.tcl$RESET."
    sed -i "s/\(pubkey \"\).*\"/\1${PUBLICKEY}\"/" /web/cgi-bin2/cryptophotoconf.tcl

    echo -e "Updating ${COLOR}privkey$RESET in $COLOR/web/cgi-bin2/cryptophotoconf.tcl$RESET."
    sed -i "s/\(privkey \"\).*\"/\1${PRIVATEKEY}\"/" /web/cgi-bin2/cryptophotoconf.tcl

    echo -e "Updating ${COLOR}salt$RESET in $COLOR/web/cgi-bin2/cryptophotoconf.tcl$RESET."
    sed -i "s/\(salt \"\).*\"/\1${SALT}\"/" /web/cgi-bin2/cryptophotoconf.tcl

    read -p "Enable CryptoPhoto service (y/n): " ENABLE

    if [[ $ENABLE =~ ^[Yy]$ ]]; then
        echo -e "Changing ${COLOR}cpenabled$RESET to ${COLOR}1$RESET in $COLOR/web/cgi-bin2/cryptophotoconf.tcl$RESET."
        sed -i "s/variable cpenabled ${ECPENABLED}/variable cpenabled 1/" /web/cgi-bin2/cryptophotoconf.tcl
    else
        sed -i "s/variable cpenabled ${ECPENABLED}/variable cpenabled 0/" /web/cgi-bin2/cryptophotoconf.tcl
        echo -e "You will need to change ${COLOR}cpenabled$RESET to ${COLOR}1$RESET in $COLOR/web/cgi-bin2/cryptophotoconf.tcl$RESET when you are ready to use CryptoPhoto Services."
    fi
}

finish_installation

echo "Configuration finished."