#! /usr/bin/ipstcl2

set env(ALLOWED_KEYS_WITH_SPECIAL_CHARS) "userPass"
ipso

source cryptophotoconf.tcl

# **** Debug section ****
source debug.tcl
variable dFile "/tmp/home.debug"

# Session string from Apache session module
set sid ""
if {[info exists env(SESSION_STRING)]} {
    set sid $env(SESSION_STRING)
}
#TEXT "session_id = $sid"
dmsg ""

if {[info exists env(MULTIPORTAL_PATH_PREFIX)]} {

	set MP_PREFIX1  $env(MULTIPORTAL_PATH_PREFIX)

	set MP_PREFIX_LEN [string last  "/" $MP_PREFIX1]
	if { ${MP_PREFIX_LEN} < 0 } {

		set MP_PREFIX ""
	} else {	
		set MP_PREFIX [string range $MP_PREFIX1 1 $MP_PREFIX_LEN]
	}
	dmsg "MP_PREFIX=$MP_PREFIX"
} else {	
	set MP_PREFIX ""
}

dmsg "MP_PREFIX=$MP_PREFIX"

set requestURI ""
if {[info exists env(REQUEST_URI)]} {
    set requestURI $env(REQUEST_URI)
}
if { $requestURI != "" && [string first $sid $requestURI] == -1 } {
	# Initial entrance - the location returned from login.tcl does not contains session string, 
	# but after that we have _sstr (arrived from home.tcl) and we need to include it in the path.
	variable myDb
	set result 0
        if {[catch {libdb init -local} myDb]} {
        	#failed to initialize!!! Go to login page again
		set sid ""
		set requestURI "cgi-bin/login.tcl"
		set myDb ""
		set result 1
        }
	# White list - to make sure no other code is being injected in here.
	if {$requestURI != "/cgi-bin/home.tcl" } {
		set result 1
	} else {
		global cpenabled                                                                                                                                                                                                                 
                if { $cpenabled == 1 } {
                    if { [file exists "/tmp/_cplock_$USER"] == 1} {
                        file delete "/tmp/_cplock_$USER"
                    } else {
                        set requestURI "cgi-bin/login.tcl"
                    }
                }
		
		HTML "<!DOCTYPE html>"
		HTML "<html>"
		HTML "<script type=\"text/javascript\">"
		HTML "location.href = \"/$MP_PREFIX$sid$requestURI\";"
		HTML "</script>"
		HTML "</html>"
	}
	if { $result == 0 } {
		set count [libdb get $myDb "webuiparams:logincount:$USER"]
		if { $count == "" } {
			set count 0
		}
		
		set count [expr $count + 1]
		set result [libdb set $myDb "webuiparams:logincount:$USER" $count]
		
		set update_upgrade_exec [libdb get $myDb "update_upgrade_info:set_counter"]
		if { $update_upgrade_exec == "" } {
			set res [libdb set $myDb "update_upgrade_info:set_counter" "t"]	
		}			
		libdb close $myDb
	}
	exit 0
}

proc set_stylesheet {css_file} {
    global sid
	global MP_PREFIX
    HTML "<link rel=\"stylesheet\" type=\"text/css\" href=\"/$MP_PREFIX$sid/$css_file\" />"
}

proc set_javascript_files {files} {
    global sid
	global MP_PREFIX
    foreach file_name $files {
    HTML "<script type=\"text/javascript\" src=\"/$MP_PREFIX$sid/$file_name\"></script>"
    }
}

HTML "<!DOCTYPE html>"
HTML "<html>"
HTML "<head>"
HTML "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">"
HTML "<meta http-equiv=\"X-UA-Compatible\" content=\"IE=EmulateIE9,IE=EmulateIE8\">"
HTML "<title>Gaia</title>"
HTML "<link rel=\"shortcut icon\" href='/$sid/images/icons/fav.ico'>"

#<!-- ExtJS CSS --> 
set_stylesheet "extjs4/resources/css/ext-all-gaia.css"

#<!-- ux CSS --> 
set_stylesheet "extjs/ux/LiveSearch/LiveSearchGridPanel.css"
set_stylesheet "extjs/ux/LiveSearch/statusbar/css/statusbar.css"
set_stylesheet "extjs/ux/css/CheckHeader.css"

#<!-- WebUI CSS --> 
set_stylesheet "css/xtheme-webui.css"

#<!-- Script - global variables -->
HTML "<SCRIPT type=\"text/javascript\">"
HTML "\n\
var urlContext = ''; \
var _sid = \"$MP_PREFIX$sid\"; \
var _sstr = \"/$MP_PREFIX$sid\"; \
var _userName = \"$USER\"; \
"
HTML "</script>"

#<!-- Ext JS 4 core files -->
set_javascript_files "extjs4/bootstrap.js"

#<!-- Insert all ux plugins here -->
set_javascript_files "extjs/ux/checkColumn.js \
                      extjs/ux/LiveSearch/statusbar/StatusBar.js \
                      extjs4/ux/SUProgressColumn.js \
                      extjs/ux/LiveSearch/LiveSearchGridPanel.js"
                      
#<!-- WebUI core files -->
set_javascript_files "js/util.js \
                      js/webui-core.js \
                      js/cp-vtypes4.js \
                      js/cp-wrapper4.js"

#<!-- Insert all mainframe files -->
set_javascript_files "js/statusbar.js \
                      js/centerPanel.js \
                      js/navtree.js \
                      js/toppanel.js \
                      js/mainframe.js \
                      js/coolclock.js \
                      js/moreskins.js \
                      js/overview.js \
                      raphael/raphael.js \
                      raphael/popup.js"

#<!-- Insert advanced routing one liner support script -->
set_javascript_files "js/adv_route_one_liners.js \
                      js/intf_state.js \
                      js/ip6convert.js \
                      js/addr.js \
                      js/vrrp_vmac_list.js \
                      js/ar_util.js"

#<!-- excanvas for coolclock -->
HTML "\n <!--\[if IE\]><script type=\"text/javascript\" src=\"/$sid/js/excanvas.js\"></script><!\[endif\]--> \n"
        
HTML "<script type=\"text/javascript\">Ext.onReady(CP.UI.init);</script>"
HTML "</head>"
HTML "<body class='webui-onload'>"
HTML "</body>"
HTML "<div id=\"loading-mask\"></div>"
HTML "<div id=\"loading\">"
HTML "  <div class=\"loading-indicator\">"
#HTML "Loading..."
HTML "  </div>"
HTML "</div>"
HTML "</html>"
