#!/usr/bin/ipstcl2
# Copyright: Check Point Software.

set method [get_Method]
source show_result.tcl
source subs.tcl
set show_lock_options 0

source cryptophotoconf.tcl

proc main_proc  {targv0 targc targv} {
    global userName userPass SAVE_REQ nextURL env MP_PREFIX
    global show_lock_options
        
    set SAVE_REQ false
    voyager_audit skip_during_ipso ; # Logins are logged separately.
    ipso

    if {![info exists MP_PREFIX]} {
	 set MP_PREFIX ""
    } 

    if {![info exists nextURL]} {
       if {[info exists env(nextURL)]} {
            set nextURL $env(nextURL)
            set homeURLs {"/" "/cgi-bin/login.tcl" "/cgi-bin/login_adv.tcl" \
                        "/cgi-bin/login_chpass.tcl" "/voyager/applysf.htm"}
            if {[lsearch -exact $homeURLs $nextURL] >= 0} {
              set nextURL "/cgi-bin/home.tcl"
          }
       } else {
          set nextURL "/cgi-bin/home.tcl"
       }
    } 
    if {[string first "/cgi-bin/logout" $nextURL] != -1} {
        set nextURL "/cgi-bin/home.tcl"
    }

    global cpenabled
    if { $cpenabled == 1 } {
        set nextURL "/cgi-bin/login_adv.tcl"
    } else {
        set nextURL "/cgi-bin/home.tcl"
    }

    if {[info exists env(SESSION_STRING)]} {
        set nextURL "$env(SESSION_STRING)${nextURL}" 
    }
    
    if {![info exists userName]} {
        set userName ""
    } 
    if {![info exists userPass]} {
        set userPass ""
    } 

    # replace with Internationalized values when supported
    set uname_txt "User Name"
    set uname_prompt "Enter user name"
    set passwd_txt "Password"
    set passwd_prompt "Enter user password"
    set cfglock_txt "Acquire Exclusive Configuration Lock"
    set advlink_txt "Log In with Advanced Options"

    set msgText ""
    if {[info exists env(ERROR_STRING)]} {
        set msgText $env(ERROR_STRING)
    }
   
    HTML "<!DOCTYPE html>"
	HTML "<HTML><HEAD>\n"
    HTML "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">"
    HTML "<meta http-equiv=\"X-UA-Compatible\" content=\"IE=EmulateIE9,EmulateIE8\">"
    HTML "<meta name=\"others\" content=\"WEBUI LOGIN PAGE\"  />"
    HTML "<TITLE>Gaia</TITLE>\n"
    HTML "<link rel=\"shortcut icon\" href=\"/login/fav.ico\"> \n"

    # note: styles in-line because styles are not used when loaded from CSS
    HTML "<link rel=\"stylesheet\" type=\"text/css\" href=\"$MP_PREFIX/login/ext-all.css\" />\n"
    HTML "<link rel=\"stylesheet\" type=\"text/css\" href=\"$MP_PREFIX/login/login.css\" />\n"
    
    # IE has a different background color 
    HTML "<STYLE TYPE=\"text/css\">\n"
    HTML ".ext-ie .webui-login-fld{font-size: 11px;}"
    HTML "\n</STYLE>\n"

    # Notes:
    # 1. recommended practice of putting JavaScript code in an HTML comment
    #    (<!-- ... -->) did not seem to work, as the function was always
    #    reported as undefined by NS6;
    #    for now, the HTML comment indicators are left out
    #
    # 2. the if-stmt in removeAllFramesForLogin() is necessary to prevent IE5.5
    #    from having an infinite loop; NS6 did not seem to have the problem
    #
    # 3. it is not possible to use a JavaScript file, since the "session
    #    module" in the Web Server won't allow any GETs until a session
    #    is established.
    #
    HTML "<script type=\"text/javascript\" src=\"$MP_PREFIX/login/ext-base.js\"></script>"
    HTML "<script type=\"text/javascript\" src=\"$MP_PREFIX/login/ext-all.js\"></script>"
    HTML "<script type=\"text/javascript\">"
    HTML "var errMsgText = \"\";"
    HTML "var bannerMsgText = \"\";"
    if {[info exists env(ERROR_STRING)]} {
        HTML "errMsgText += \"$env(ERROR_STRING)\";"
    }
    
    # build the banner message
    catch {libdb init -local} myDb
    set banText ""
    set banStatus [libdb get $myDb "message:banner:status"]
    if { [string match $banStatus "on"] == 1} {
        set txtChunk 1
        set bindNos 0
        set bindNos [libdb get $myDb "message:banner:chunks"]
        for {set i 1} {$i <= $bindNos} {incr i} {
            set txtChunk [libdb get $myDb "message:banner:content:$i"]
            append banText $txtChunk
        }
        if { $banText == "" } {
            set banText [libdb get $myDb "message:banner:default"]
        }
    }
    
    #encode html and replace line break with br tag
    if { $banText != "" } {
        set banText [html_escape $banText]
        set banText [string map {"\n" "<br>"} $banText]
    }
    
    HTML "bannerMsgText += \"$banText\";"
    # build the caption hostname message
    set capStatus [libdb get $myDb "message:caption:status"]
	set hostTxt ""
    if { [string match $capStatus "on"] == 1} {
	set hostTxt [libdb get $myDb "machine:hostname"]
    }
    HTML "var hostname=\'[html_escape ${hostTxt}]\';"
    #set verTxt [exec cpprod_util CPPROD_GetVerText CPshared] - currently not working - no permissions
    set verTxt [libdb get $myDb "webuiparams:ea"]
    if { $verTxt == "t" } {
	    set verTxt "Early Availablity"
    } else {
	    set verTxt [libdb get $myDb "snap:show:current:version"]
    }
    set vsxMode [libdb get $myDb "vsx"]
    HTML "var version=\'[html_escape ${verTxt}]\';"
    HTML "var formAction=\"[html_escape ${nextURL}]\";"
    HTML "</script>"
    if { $vsxMode == "t" } {
	    HTML "<p align=\"center\" style=\"font-style:normal;font-size:20;padding-top:20%\">Web UI is not supported in VSX mode. Please use Clish for OS configuration.</p>"
    } else {
    	HTML "<script type=\"text/javascript\" src=\"$MP_PREFIX/login/login.js\"></script>"
    }
    HTML "</HEAD>"
    HTML "<BODY>"
    HTML "<noscript><div style='font-size:20px;position:relative;top:100px;'>For full functionality of this site it is necessary to enable JavaScript.</div></noscript>"
    HTML "</BODY></HTML>"
    
    libdb close $myDb
    exit
}

main_proc $argv0 $argc $argv
